% Program Figures_2_4_2_7
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
%Figure_2_4
N = 41; % Length of the sequence
n = 0:N-1; % Time index
x = 0.6*sin(2*pi*0.0625*n)+0.3*sin(2*pi*0.2*n); % Original signal
M = 2; % Down-sampling factor
y = x(1:M:N); % Down-sampled signal
L = length(y); % Length of the down-sampled sequence
figure (1)
subplot(2,1,1), stem(0:N-1,x(1:N))
xlabel('Time index n'), ylabel('x[n]')
subplot(2,1,2)
stem(0:L-1,y(1:L))
xlabel('Time index m'), ylabel('y[m]')

% Figure_2_7
N = 21;      % Length of the original sequence
n = 0:N-1;  % Time index
x = 0.7*sin(2*pi*0.0625*n)+0.3*sin(2*pi*0.2*n); % Original signal
L = 2; % Up-sampling factor
y = zeros(1,L*length(x)); 
y([1:L:length(y)])= x; % Up-sampled signal
Ny = length(y) - L + 1   % Length of the up-sampled signal
figure (2)
subplot(2,1,1)
stem(0:20,x(1:21))
xlabel('Time index n'), ylabel('x[n]')
subplot(2,1,2)
stem(0:40,y(1:41))
xlabel('Time index m'), ylabel('y[m]')
