% Program demo_2_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Spectrum of down-sampled signal
clear all, close all
% Generating the input signal 'x'
F = [0,0.1,0.46,1]; A=[0,1,0,0];         % Setting the input parameters for fir2
x = fir2(256,F,A); % Generating the original signal 'x'
X = fft(x,1024);     % Computing the spectrum of the original signal
f = 0:1/512:(512-1)/512; % Normalized frequencies
figure (1)
subplot(4,1,1), plot(f,abs(X(1:512))), text(0.9,0.7,'(a)')
ylabel('|X(e^j^\omega)|')
 
M = 2;  % Down-sampling factor
y2 = x(1:M:256);   % Down-sampling 
Y2 = fft(y2,1024);   % Computing the spectrum of the down-sampled signal
subplot(4,1,2), plot(f,abs(Y2(1:512))), text(0.9,0.35,'(b)')
ylabel('|Y_2(e^j^\omega)|'),
 
M = 3;  % Down-sampling factor
y3 = x(1:M:256);   % Down-sampling
Y3 = fft(y3,1024);  % Computing the spectrum of the down-sampled signal
subplot(4,1,3), plot(f,abs(Y3(1:512))),text(0.9,0.3,'(c)')
ylabel('|Y_3(e^j^\omega)|')
 
M = 4;   % Down-sampling factor
y4=x(1:M:256);   % Down-sampling
Y4 = fft(y4,1024);  % Computing the spectrum of the down-sampled signal
subplot(4,1,4), plot(f,abs(Y4(1:512))),text(0.9,0.2,'(d)')
axis([0,1,0,0.4])
ylabel('|(Y_4(e^j^\omega)|'), xlabel('\omega/\pi')
