% Program demo_2_10
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Equivalent frequency response of the three-stage decimator
clear all, close all
h1 = fir1(30,0.5); % FIR filter H1(z)
[H1,f] = freqz(h1,1,512,2);
figure (1)
subplot(4,1,1), plot(f,abs(H1)), ylabel('|H_1(e^{j\omega})|')
axis([0,1,0,1.2])
 
M = 2;
h2 = zeros(1,M*length(h1)); 
h2([1:M:length(h2)]) = h1; % H2(z) = H1(z^2)
[H2,f] = freqz(h2,1,512,2);
subplot(4,1,2), plot(f,abs(H2)), ylabel('|H_1(e^{j2\omega})|')
axis([0,1,0,1.2])
 
M = 4;
h3 = zeros(1,M*length(h1)); 
h3([1:M:length(h3)]) = h1; %  H3(z) = H1(z^4)
[H3,f] = freqz(h3,1,512,2);
subplot(4,1,3), plot(f,abs(H3)), ylabel('|H_1(e^{j4\omega})|')
axis([0,1,0,1.2])
 
H = H1.*H2.*H3; % Equivalent filter
subplot(4,1,4), plot(f,abs(H)),ylabel('|(H(e^{j\omega})|') 
xlabel('\omega/\pi'), axis([0,1,0,1.2])
