% Program demo_2_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Spectrum of the up-sampled signal
clear all, close all
% Input signal 'x'
F = [0,0.2,0.9,1]; A = [0,1,0,0];  % Setting the input parameters for fir2
x = fir2(128,F,A); % Generating the original signal x
X = fft(x,1024);   % Computing the spectrum of the original signal
f = 0:1/512:(512-1)/512;  % Normalized frequencies
figure (1)
subplot(4,1,1), plot(f,abs(X(1:512)))
ylabel('|X(e^j^\omega)|'), text(0.9,0.6,'(a)')
 
L = 2; % Up-sampling factor
y2 = zeros(1,L*length(x)); 
y2([1:L:length(y2)]) = x; % Up-sampled signal, L=2
Y2 = fft(y2,1024); % Computing the spectrum of the up-sampled signal
subplot(4,1,2), plot(f,abs(Y2(1:512)))
ylabel('|Y_2(e^j^\omega)|'), text(0.9,0.5,'(b)')
 
L = 3; % Up-sampling factor
y3 = zeros(1,L*length(x)); 
y3([1:L:length(y3)]) = x; % Up-sampled signal, L=3
Y3 = fft(y3,1024);  % Computing the spectrum of the up-sampled signal
subplot(4,1,3), plot(f,abs(Y3(1:512)))
ylabel('|Y_3(e^j^\omega)|'), text(0.9,0.6,'(c)')
 
L = 4; % Up-sampling factor
y4 = zeros(1,L*length(x)); 
y4([1:L:length(y4)]) = x; % up-sampled signal, L=4
Y4 = fft(y4,1024);  % Computing the spectrum of the up-sampled signal
subplot(4,1,4), plot(f,abs(Y4(1:512)))
ylabel('|(Y_4(e^j^\omega)|'), xlabel('\omega/\pi'), text(0.9,0.5,'(d)')
