% Program demo_2_3
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Spectrum of decimated signal
clear all, close all
% Input signal 'x'
F  =[0,0.1,0.46,1]; A = [0,1,0,0];  % Setting the input parameters for fir2
x1 = fir2(256,F,A); x2 = 0.01*cos(2*pi*0.35*(0:256)); % Generating the signal components
x = x1 + x2; % Original signal
X = fft(x,1024); % Computing the spectrum of the original signal
f = 0:1/512:(512-1)/512; % Normalized frequencies
figure (1)
subplot(3,1,1), plot(f,abs(X(1:512)))
ylabel('|X(e^j^\omega)|'), text(0.9,0.8,'(a)')
 
% Down-sampled signal
M = 2;  % Down-sampling factor
y = x(1:M:256);  % Down-sampling
Y = fft(y,1024);   % Computing the spectrum of the down-sampled signal
subplot(3,1,2), plot(f,abs(Y(1:512)))
ylabel('|Y(e^j^\omega)|'), text(0.9,0.5,'(b)')
 
% Decimated signal
yd = decimate(x,M);        % Decimated signal
Yd = fft(yd,1024);         % Computing the spectrum of the decimated signal 
subplot(3,1,3), plot(f,abs(Yd(1:512)))
xlabel('\omega/\pi'),ylabel('|Y_d(e^j^\omega)|'), text(0.9,0.5,'(c)')
