% Program demo_2_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Spectrum of interpolated signal
% Program generates Figure2_15 and Figure2_16.
clear all, close all
% Input signal 'x'
F = [0,0.2,0.9,1]; A = [0,1,0,0]; % Setting the input parameters for fir2
x = fir2(128,F,A); % Generating the original signal x
X = fft(x,1024);  % Computing the spectrum of the original signal
f = 0:1/512:(512-1)/512; % Normalized frequencies
figure (1)
subplot(3,1,1), plot(f,abs(X(1:512)))
ylabel('|X(e^j^\omega)|'), text(0.9,0.5,'(a)')
 
L = 4;  % Up-sampling factor
xu = zeros(1,L*length(x)); 
xu([1:L:length(xu)]) = x; % Up-sampled signal
Xu = fft(xu,1024);  % Computing the spectrum of the up-sampled signal
subplot(3,1,2), plot(f,abs(Xu(1:512)))
ylabel('|X_u(e^j^\omega)|'), text(0.9,0.5,'(b)')
 
y = interp(x,L); % Interpolated signal
Y = fft(y,1024); % Computing the spectrum of the up-sampled signal
subplot(3,1,3), plot(f,abs(Y(1:512)))
ylabel('|(Y(e^j^\omega)|'), xlabel('\omega/\pi'), text(0.9,2,'(c)')

% Time domain presentation
figure (2)
subplot(3,1,1), stem(54:74,x(55:75))
ylabel('x[n]'), text(72,0.35,'(a)')
subplot(3,1,2), stem(L*55-1:L*74-1,xu(L*55-1:L*74-1))
ylabel('x_u[m]'), text(288,0.33,'(b)')
axis([L*55-1,L*74-1,-0.5,0.5])
subplot(3,1,3), stem(L*55-1:L*74-1,y(L*55-1:L*74-1))
ylabel('y[m]'), xlabel('Time index'), text(288,0.33,'(c)')
axis([L*55-1,L*74-1,-0.5,0.5])
