% Program demo_2_5
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Illustration of the Third Identity
clear all, close all
n = 0:60;  % Time index
x = cos(2*pi*0.05*n); % Generating the original signal
h = fir1(10,0.5); % Designing the  filter transfer function H(z) 
hu = upsample(h,4); % Transfer function H(z^4)
y1 = filter(hu,1,x); % Filtering
y = downsample(y1,4); % Down-sampling
m = 0:length(y)-1; % Time index
figure (1)
subplot(3,2,1), stem(n,x), ylabel('x[n]')
title('Figure 2.20(a): x[n],y_1[n],y[m]')
subplot(3,2,3), stem(n,y1), ylabel('y_1[n]')
subplot(3,2,5), stem(m,y), ylabel('y[m]')
xlabel('Time index')
y2 = downsample(x,4); % down-sampling
y = filter(h,1,y2); % filtering
subplot(3,2,2), stem(n,x),ylabel('x[n]')
title('Figure 2.20(a): x[n],y_2[m],y[m]')
subplot(3,2,4), stem(m,y2), ylabel('y_2[m]')
subplot(3,2,6), stem(m,y),ylabel('y[m]') 
xlabel('Time index')
