% Program demo_2_6
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Illustration of the Sixth Identity
clear all, close all
n = 0:15; % Time index
x = cos(2*pi*0.1*n); % Generating the original signal
h = fir1(10,0.5); % Designing the filter transfer function H(z)
hu = upsample(h,2); % Transfer function H(z^2)
y1 = filter(h,1,x); % Filtering
y = upsample(y1,2); % Up-sampling
m = 0:length(y)-1; % Time index
figure (1)
subplot(3,2,1), stem(n,x), ylabel('x[n]')
title('Figure 2.24(a): x[n],y_1[n],y[m]')
subplot(3,2,3), stem(n,y1),ylabel('y_1[n]') 
subplot(3,2,5), stem(m,y), ylabel ('y[m]')
xlabel('Time index')
axis([0,30,-1,1])
y2 = upsample(x,2); % Up-sampling
y = filter(hu,1,y2); % Filtering
subplot(3,2,2), stem(n,x), ylabel('x[n]')
title('Figure 2.24(b): x[n],y_2[m],y[m]')
subplot(3,2,4), stem(m,y2), ylabel('y_2[m]')
axis([0,30,-1,1])
subplot(3,2,6), stem(m,y), ylabel('y[m]')
xlabel('Time index')
axis([0,30,-1,1])
