% Program demo_2_7
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Converting the sampling rate by the rational factor L/M=2/3
clear all, close all
n = 0:15;  % Time index
L = 2; M = 3; % Up-sampling and down-sampling factors
x = cos(2*pi*0.1*n); % Generating the original signal
v1 = upsample(x,L);  % Up-sampling
y = downsample(v1,M);  % Down-sampling
r = 0:length(v1)-1;  % Time index
m = 0:length(y)-1;  % Time index
figure (1)
subplot(3,2,1), stem(n,x), ylabel('x[n]')
title('Figure 2.26(a): x[n],v_1[r],y[m]')
subplot(3,2,3), stem(r,v1), ylabel('v_1[r]')
axis([0,30,-1,1])
subplot(3,2,5), stem(m,y), ylabel('y[m]')
xlabel('Time index')
v2 = downsample(x,M);  % Down-sampling
r = 0:length(v2)-1;  % Time index
y = upsample(v2,L); % Up-sampling
m = 0:length(y)-1;  % Time index
subplot(3,2,2), stem(n,x), ylabel('x[n]')
title('Figure 2.26(b): x[n],v_2[r],y[m]')
subplot(3,2,4), stem(r,v2), ylabel('v_2[r]')
axis([0,5,-1,1])
subplot(3,2,6), stem(m,y), ylabel('y[m]')
xlabel('Time index')
axis([0,10,-1,1])
