% Program demo_2_8
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Down-sampling with the phase offset
% Analysis in the frequency domain
clear all, close all
% Generating the original signal 'x'
F = [0,0.1,0.46,1]; A = [0,1,0,0];  % Setting the input parameters for fir2
x = fir2(256,F,A); % Generating the original signal 'x'
X = fft(x,1024);  % Computing the signal spectrum
f = 0:1/512:(512-1)/512; % Normalizad frequencies
figure (1)
subplot(3,2,1), plot(f,abs(X(1:512))), text(0.8,0.7,'(a)')
ylabel('|X(e^{j\omega})|'), axis([0,1,0,1])
 
M = 2; % Down-sampling factor
y0 = downsample(x,M); % down-sampling without phase offset
Y0 = fft(y0,1024); % Computing the signal spectrum
subplot(3,2,3), plot(f,abs(Y0(1:512))), text(0.8,0.7,'(b)')
ylabel('|Y_0(e^{j\omega})|'), axis([0,1,0,1])
 
y1 = downsample(x,M,1); % Down-sampling with the phase offset
Y1 = fft(y1,1024); % Computing the signal spectrum
subplot(3,2,5), plot(f,abs(Y1(1:512))), text(0.8,0.7,'(c)')
ylabel('|Y_1(e^{j\omega})|'), xlabel('\omega/\pi'), axis([0,1,0,1])
 
F = [0,0.1,0.7,1]; A = [0,1,0,0]; % Setting the input parameters for fir2
v = fir2(256,F,A);  % Generating the input signal 'v'
V = fft(v,1024);  % Computing the signal spectrum
f = 0:1/512:(512-1)/512;  % Normalized frequencies
figure (1)
subplot(3,2,2), plot(f,abs(V(1:512))), text(0.8,0.7,'(d)')
ylabel('|V(e^{j\omega})|'), axis([0,1,0,1])
 
w0=downsample(v,M); % Down-sampling without phase offset
W0=fft(w0,1024); % Computing the signal spectrum
subplot(3,2,4), plot(f,abs(W0(1:512))), text(0.8,0.7,'(e)')
ylabel('|W_0(e^{j\omega})|'), axis([0,1,0,1])
 
w1 = downsample(v,M,1);  % Down-sampling with the phase offset
W1=fft(w1,1024); % Computing the signal spectrum
subplot(3,2,6), plot(f,abs(W1(1:512))), text(0.8,0.7,'(f)')
ylabel('|W_1(e^{j\omega})|'), xlabel(' \omega/\pi'), axis([0,1,0,1])
