% Program: demo_2_9
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Polyphase decomposition and reconstruction
% Input signal
clear all, close all
n = 0:63;
x = zeros(size(n)); x(11:39) = 0.95.^(1:29); % Generating the sequence x
 
% Polyphase down-sampling with the phase offset
x0 = downsample(x,4);
x1 = downsample(x,4,1);
x2 = downsample(x,4,2);
x3 = downsample(x,4,3);
 
% Up-sampling polyphase components with the phase offset
y0 = upsample(x0,4);
y1 = upsample(x1,4,1);
y2 = upsample(x2,4,2);
y3 = upsample(x3,4,3);
figure (1)
subplot (4,1,1), stem(0:length(x0)-1,x0),ylabel('x_0[m]')
subplot (4,1,2), stem(0:length(x1)-1,x1),ylabel('x_1[m]')
subplot (4,1,3), stem(0:length(x2)-1,x2),ylabel('x_2[m]')
subplot (4,1,4), stem(0:length(x3)-1,x3),ylabel('x_3[m]')
xlabel('Time index m')
 
y = y0 + y1 + y2 + y3; % Adding together up-sampled polyphase components
figure (2)
subplot(2,1,1),stem(n,x), ylabel('x[n]'), axis([0,63,0,1])
subplot(2,1,2),stem(n,y), ylabel('y[n]'), axis([0,63,0,1])
xlabel('Time index n')
